## plplot 5.10.0

=== data/CMakeLists.txt ===
# data/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

set(data_DATAFILES
plstnd5.fnt
plxtnd5.fnt
cmap0_default.pal
cmap0_alternate.pal
cmap0_white_bg.pal
cmap0_black_on_white.pal
cmap1_default.pal
cmap1_blue_yellow.pal
cmap1_blue_red.pal
cmap1_gray.pal
cmap1_radar.pal
cmap1_highfreq.pal
cmap1_lowfreq.pal
)

if(HAVE_SHAPELIB)
  set(data_DATAFILES
  ${data_DATAFILES}
  cglobe.shx
  cglobe.shp
  globe.shx
  globe.shp
  usa.shx
  usa.shp
  usaglobe.shx
  usaglobe.shp
  )
  set(data_DOCFILES
  README.shapefiles
  )
else(HAVE_SHAPELIB)
  set(data_DATAFILES
  ${data_DATAFILES}
  cglobe.map
  globe.map
  usa.map
  usaglobe.map
  )
endif(HAVE_SHAPELIB)

install(FILES ${data_DATAFILES} DESTINATION ${DATA_DIR})

if(HAVE_SHAPELIB)
  install(FILES ${data_DOCFILES} DESTINATION ${DOC_DIR})
endif(HAVE_SHAPELIB)

=== doc/CMakeLists.txt ===
# Process documentation for the PLplot project.

# Process man pages in this subdirectory.

set(core_manpages pltek.1)

if(PLD_pstex)
  set(core_manpages ${core_manpages} pstex2eps.1)
endif(PLD_pstex)

if(PLD_plmeta)
  set(core_manpages ${core_manpages} plrender.1 plm2gif.1 plpr.1)
endif(PLD_plmeta)

set(tcl_manpages plserver.1 pltcl.1)

set(manpages ${core_manpages})
if (ENABLE_tcl)
  set(manpages ${manpages} ${tcl_manpages})
endif (ENABLE_tcl)

install(FILES ${manpages} DESTINATION ${MAN_DIR}/man1)

# Process the docbook documentation.
add_subdirectory(docbook) 

# Process the doxygen documentation.

if(BUILD_DOX_DOC)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY
    )

  # Attempt to collect the same source-code files that are specified
  # by the INPUT parameter in Doxyfile(.in).  Note, this includes
  # all configured files in the build tree because all source
  # subdirectories are processed by the top-level CMakeLists.txt file
  # before this doc subdirectory.  However, these dependencies will
  # miss at cmake time the files in the build tree that are generated
  # at run time.

  set(doxygen_prefixes  "*.c;*.cc;*.cxx;*.cpp;*.c++;*.d;*.java;*.h;*.py;*.f90;*.f")
  set(doxygen_directories 
    ${CMAKE_SOURCE_DIR}/lib
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/drivers
    ${CMAKE_SOURCE_DIR}/bindings
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/lib
    ${CMAKE_BINARY_DIR}/bindings
    ${CMAKE_BINARY_DIR}/include
    )
  set(doxygen_globs )
  foreach(directory ${doxygen_directories})
    foreach(prefix ${doxygen_prefixes})
      list(APPEND doxygen_globs ${directory}/${prefix})
    endforeach(prefix ${doxygen_prefixes})
  endforeach(directory ${doxygen_directories})
  # Must append one specific configured file to be consistent with
  # the INPUT parameter in Doxyfile(.in).
  list(APPEND doxygen_globs ${CMAKE_BINARY_DIR}/plplot_config.h)
  #message(STATUS "DEBUG: doxygen_globs = ${doxygen_globs}")

  # RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} works (because that is the
  # [default] working directory for running the doxygen command) and makes the
  # resulting paths substantially shorter, but is actually not
  # necessary.
  file(GLOB_RECURSE doxygen_file_depends
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    ${doxygen_globs}
    )
  #message(STATUS "DEBUG: doxygen_file_depends = ${doxygen_file_depends}")

  # Notes: OUTPUT file is a directory so this insures "make clean"
  # removes that directory.
  add_custom_command(
    OUTPUT
    ${CMAKE_CURRENT_BINARY_DIR}/doxygen
    COMMAND ${DOXYGEN_EXECUTABLE}
    DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    ${doxygen_file_depends}
    )
  add_custom_target(build_doxygen ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen
    )

  # Add some library dependencies that will insure all run-time
  # generated source files will be correctly processed by doxygen.
  # These won't have the proper file dependencies (see comment above)
  # so the doxygen documentation won't be remade if one of these
  # run-time files is regenerated, but source-file regeneration (which
  # would be caused by editing one of the prerequisites of these
  # generated source files) should be a rare case in practice.
  add_dependencies(build_doxygen plplot${LIB_TAG})
  # Generated C code for the Tcl bindings.
  if(ENABLE_tcl)
    add_dependencies(build_doxygen plplottcltk${LIB_TAG})
  endif(ENABLE_tcl)
  # Generated C (and C++ in the Octave case) code for the
  # swig-generated bindings.
  if(ENABLE_python)
    add_dependencies(build_doxygen _plplotcmodule)
  endif(ENABLE_python)
  if(ENABLE_java)
    add_dependencies(build_doxygen plplotjavac_wrap)
  endif(ENABLE_java)
  if(ENABLE_lua)
    add_dependencies(build_doxygen plplotluac)
  endif(ENABLE_lua)
  if(ENABLE_octave)
    add_dependencies(build_doxygen plplot_octave)
  endif(ENABLE_octave)

  install(CODE "
message(STATUS \"Installing: \$ENV{DESTDIR}${DOC_DIR}/doxygen tree\")
execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_BINARY_DIR}/doxygen \$ENV{DESTDIR}${DOC_DIR}/doxygen)
")
  if(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
    add_custom_target(
      www-install-doxygen
      ssh ${WWW_USER}@${WWW_HOST} mkdir -p ${WWW_DIR}/htdocs/doxygen
      COMMAND rsync -avq ${CMAKE_CURRENT_BINARY_DIR}/doxygen/ ${WWW_USER}@${WWW_HOST}:${WWW_DIR}/htdocs/doxygen
      )
    add_dependencies(www-install-doxygen build_doxygen) 
  endif(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
endif(BUILD_DOX_DOC)

=== drivers/CMakeLists.txt ===
# drivers/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

install(
  FILES README.drivers README.wxwidgets
  DESTINATION ${DOC_DIR}
  )

if(ENABLE_DYNDRIVERS)
  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_SOURCE_DIR}/lib/nistcd
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )

  option(TEST_DYNDRIVERS "Test dynamic drivers" ON)
  if(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir)

    set_source_files_properties(
      test-drv-info.c
      PROPERTIES COMPILE_FLAGS "-I${LTDL_INCLUDE_DIR} -DUSINGDLL"
      )

    add_executable(test-drv-info test-drv-info.c)
    target_link_libraries(test-drv-info
      plplot${LIB_TAG}
      ${LTDL_LIBRARIES}
      )

    # in windows we move test-drv-info to the dll directory
    # otherwise we use the RPATH functionality
    if(USE_DLL_SUBDIRECTORY)
      set_target_properties(
	test-drv-info
	PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/dll
	)
    else(USE_DLL_SUBDIRECTORY)
      set(test-drv-info_RPATH
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_BINARY_DIR}/src
        ${CMAKE_BINARY_DIR}/lib/csa
        ${CMAKE_BINARY_DIR}/lib/nn
        ${CMAKE_BINARY_DIR}/lib/qsastime
        ${libplplot${LIB_TAG}_RPATH}
        )

      set_target_properties(
        test-drv-info
        PROPERTIES
        INSTALL_RPATH "${test-drv-info_RPATH}"
        BUILD_WITH_INSTALL_RPATH ON
        )
    endif(USE_DLL_SUBDIRECTORY)
    get_target_property(test-drv-info_LOCATION test-drv-info LOCATION)
    set(test_dyndrivers_TDEPENDS test-drv-info)

  endif(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)

  foreach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
    #message("${SOURCE_ROOT_NAME}_SOURCE = ${${SOURCE_ROOT_NAME}_SOURCE}")
    if(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS "${${SOURCE_ROOT_NAME}_COMPILE_FLAGS} -DUSINGDLL"
	)
      #message("${SOURCE_ROOT_NAME}_COMPILE_FLAGS = ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS}")
    else(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
	)
    endif(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)

    # ${SOURCE_ROOT_NAME}_LINK_FLAGS is ideally a list of the full path names
    # to libraries determined with find_library.  However, the list can also
    # include link flags such as the -L and -l form of specifying libraries,
    # but that way of doing things only works on Unix, and even for Unix,
    # cmake does not correctly set the rpath for the build tree results
    # for non-standard locations with the -L and -l forms.
    #message("${SOURCE_ROOT_NAME}_LINK_FLAGS = ${${SOURCE_ROOT_NAME}_LINK_FLAGS}")
    # ${SOURCE_ROOT_NAME}_TARGETS is a list of PLplot CMake targets that the
    # device driver depends on.
    #message("${SOURCE_ROOT_NAME}_TARGETS = ${${SOURCE_ROOT_NAME}_TARGETS}")

    if(SOURCE_ROOT_NAME STREQUAL "qt")
      if(ANY_QT_DEVICE)
	add_library(${SOURCE_ROOT_NAME} MODULE ${${SOURCE_ROOT_NAME}_SOURCE})
	if(NOT ENABLE_qt)
	  # Note this code is never executed considering the way the
          # build system is set up now (see cmake/modules/qt.cmake),
          # but nevertheless keep it for the future in case we ever
          # want to deal with the case where we want to build the qt
          # device without building the plplotqtd library
	  add_dependencies(${SOURCE_ROOT_NAME} moc_outfile_generated)
	endif(NOT ENABLE_qt)
	if(NOT QT_LIBRARIES)
	  message(FATAL_ERROR "Internal build system inconsistency. QT_LIBRARIESis empty but it should be populated")
	endif(NOT QT_LIBRARIES)
	
	target_link_libraries(
	  ${SOURCE_ROOT_NAME}
	  plplot${LIB_TAG}
	  ${MATH_LIB}
	  ${QT_LIBRARIES}
	  ${${SOURCE_ROOT_NAME}_TARGETS}
	  )
	# Update the target COMPILE_DEFINITIONS and INCLUDE_DIRECTORIES
	set_qt_target_properties(${SOURCE_ROOT_NAME})
      else(ANY_QT_DEVICE)
	message(FATAL_ERROR "Internal build system inconsistency.  Attempt to build dynamic qt device when ANY_QT_DEVICE is false.")
      endif(ANY_QT_DEVICE)
    else(SOURCE_ROOT_NAME STREQUAL "qt")
      add_library(${SOURCE_ROOT_NAME} MODULE ${${SOURCE_ROOT_NAME}_SOURCE})
      target_link_libraries(
	${SOURCE_ROOT_NAME}
	plplot${LIB_TAG}
	${MATH_LIB}
	${${SOURCE_ROOT_NAME}_LINK_FLAGS}
	${${SOURCE_ROOT_NAME}_TARGETS}
	)
    endif(SOURCE_ROOT_NAME STREQUAL "qt")

    # ${SOURCE_ROOT_NAME}_RPATH originally set in cmake/modules files for
    # each driver in ${DRIVERS_LIST}.  This is only used for the
    # install-tree rpath since cmake handles the build-tree rpath
    # automatically (so long as full pathnames to libraries are used).
    # Order is important here because of /usr/lib concerns.
    set(
      ${SOURCE_ROOT_NAME}_RPATH
      ${LIB_DIR}
      ${${SOURCE_ROOT_NAME}_RPATH}
      ${libplplot${LIB_TAG}_RPATH}
      )
    # Our implementation of dynamic loading using libltdl assumes
    # the prefix should always be nothing (rather than lib) and the suffix
    # should be set in a platform-dependent manner in order for libltdl
    # to find the dynamic device.
    if(WIN32_OR_CYGWIN)
      # strace showed that .dll was a must for libltdl on Cygwin.
      set(DYNAMIC_SUFFIX ".dll")
    else(WIN32_OR_CYGWIN)
      # So far this works on all non-Cygwin systems, but only Linux and
      # Mac OS X have been tested so far.
      set(DYNAMIC_SUFFIX ".so")
    endif(WIN32_OR_CYGWIN)

    #message("${SOURCE_ROOT_NAME}_RPATH = ${${SOURCE_ROOT_NAME}_RPATH}")
    if(USE_RPATH)
      set_target_properties(
	${SOURCE_ROOT_NAME}
	PROPERTIES
	PREFIX ""
	SUFFIX ${DYNAMIC_SUFFIX}
	INSTALL_RPATH
	"${${SOURCE_ROOT_NAME}_RPATH}"
	)
    else(USE_RPATH)
      set_target_properties(
	${SOURCE_ROOT_NAME}
	PROPERTIES
	PREFIX ""
	SUFFIX ${DYNAMIC_SUFFIX}
	)
    endif(USE_RPATH)

    if(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)
      get_target_property(
	${SOURCE_ROOT_NAME}_LOCATION
	${SOURCE_ROOT_NAME}
	LOCATION
	)
      add_custom_command(
	OUTPUT
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	COMMAND test-drv-info
	${SOURCE_ROOT_NAME}
	> ${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	COMMAND ${CMAKE_COMMAND} -E compare_files
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	${CMAKE_CURRENT_BINARY_DIR}/${SOURCE_ROOT_NAME}.driver_info
	DEPENDS
	${${SOURCE_ROOT_NAME}_LOCATION}
	${test-drv-info_LOCATION}
	)
      add_custom_target(test_${SOURCE_ROOT_NAME}_dyndriver
	DEPENDS
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	)
      set_property(GLOBAL
	PROPERTY FILE_DEPENDS_${SOURCE_ROOT_NAME}_dyndriver
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	)
      add_dependencies(test_${SOURCE_ROOT_NAME}_dyndriver
	test-drv-info
	${SOURCE_ROOT_NAME}
	)
      list(APPEND test_dyndrivers_TDEPENDS test_${SOURCE_ROOT_NAME}_dyndriver)
    endif(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)

    install(TARGETS ${SOURCE_ROOT_NAME}
      EXPORT export_plplot
      DESTINATION ${DRV_DIR}
      )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/${SOURCE_ROOT_NAME}.driver_info
      DESTINATION ${DRV_DIR}
      )
  endforeach(SOURCE_ROOT_NAME ${DRIVERS_LIST})

  if(PLD_tkwin AND USE_TCL_TK_STUBS)
    set_target_properties(
      tkwin
      PROPERTIES COMPILE_DEFINITIONS "USE_TCL_STUBS;USE_TK_STUBS"
      )
  endif(PLD_tkwin AND USE_TCL_TK_STUBS)

  if(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)
    add_custom_target(test_dyndrivers ALL
      )
    add_dependencies(test_dyndrivers ${test_dyndrivers_TDEPENDS})
  endif(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)

endif(ENABLE_DYNDRIVERS)

=== fonts/CMakeLists.txt ===
# fonts/CMakeLists.txt
# N.B. the plhershey-unicode-gen stuff is taken care of by
# ../include/CMakeLists.txt.  This file only used to optionally build the
# Hershey fonts.

option(BUILD_HERSHEY_FONTS "Build Hershey fonts?" OFF)

if(BUILD_HERSHEY_FONTS)

  # Build Hershey fonts.

  # Create "convenience static library" to help build Hershey fonts.

  set(libhershey_SRC
    font01.c
    font02.c
    font03.c
    font04.c
    font05.c
    font06.c
    font07.c
    font08.c
    font09.c
    font10.c
    font11.c
    )

  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime    
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )
  add_library(hershey STATIC ${libhershey_SRC})

  add_executable(generate_stndfonts stndfont.c)
  target_link_libraries(generate_stndfonts hershey plplot${LIB_TAG})

  add_executable(generate_xtndfonts xtndfont.c)
  target_link_libraries(generate_xtndfonts hershey plplot${LIB_TAG})

endif(BUILD_HERSHEY_FONTS)

=== include/CMakeLists.txt ===
# include/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/plConfig.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/plConfig.h
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/plDevs.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/plDevs.h
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/pldll.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/pldll.h
  )

set(plhershey-unicode-gen_SRCS
  ${CMAKE_SOURCE_DIR}/fonts/plhershey-unicode-gen.c
  )

if(NOT CMAKE_CROSSCOMPILING)
  add_executable(plhershey-unicode-gen ${plhershey-unicode-gen_SRCS})
else(NOT CMAKE_CROSSCOMPILING)
  SET(IMPORT_EXECUTABLES ${CMAKE_NATIVE_BINARY_DIR}/include/ImportExecutables.cmake)
  INCLUDE(${IMPORT_EXECUTABLES})
endif(NOT CMAKE_CROSSCOMPILING)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plhershey-unicode.h
  COMMAND plhershey-unicode-gen
  ${CMAKE_SOURCE_DIR}/fonts/plhershey-unicode.csv
  ${CMAKE_CURRENT_BINARY_DIR}/plhershey-unicode.h
  DEPENDS
  plhershey-unicode-gen
  ${CMAKE_SOURCE_DIR}/fonts/plhershey-unicode.csv
  )

if(NOT CMAKE_CROSSCOMPILING) 
  export(TARGETS plhershey-unicode-gen FILE ${CMAKE_CURRENT_BINARY_DIR}/ImportExecutables.cmake )
endif(NOT CMAKE_CROSSCOMPILING) 

# For cross-directory dependencies....
add_custom_target(
  plhershey-unicode.h_built
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/plhershey-unicode.h
  )

set(include_INSTALLED_HEADERS
  disptab.h
  drivers.h
  pdf.h
  pldebug.h
  ${CMAKE_CURRENT_BINARY_DIR}/pldll.h
  plevent.h
  plplot.h
  plplotP.h
  plstrm.h
  plxwd.h
  gcw.h
  plplotcanvas.h
  ${CMAKE_CURRENT_BINARY_DIR}/plConfig.h
  ${CMAKE_CURRENT_BINARY_DIR}/plDevs.h
  )

#qt.h only useful if anyone wants to build a Qt application with the Qt widget driver
if(PLD_qtwidget OR PLD_extqt)
  list(APPEND include_INSTALLED_HEADERS qt.h)
endif(PLD_qtwidget OR PLD_extqt)

if(ANY_QT_DEVICE)
  set(MOC_OPTIONS)
  if(PLD_bmpqt)
    list(APPEND MOC_OPTIONS -DPLD_bmpqt)
  endif(PLD_bmpqt)
  if(PLD_jpgqt)
    list(APPEND MOC_OPTIONS -DPLD_jpgqt)
  endif(PLD_jpgqt)
  if(PLD_pngqt)
    list(APPEND MOC_OPTIONS -DPLD_pngqt)
  endif(PLD_pngqt)
  if(PLD_ppmqt)
    list(APPEND MOC_OPTIONS -DPLD_ppmqt)
  endif(PLD_ppmqt)
  if(PLD_tiffqt)
    list(APPEND MOC_OPTIONS -DPLD_tiffqt)
  endif(PLD_tiffqt)
  if(PLD_svgqt)
    list(APPEND MOC_OPTIONS -DPLD_svgqt)
  endif(PLD_svgqt)
  if(PLD_epsqt)
    list(APPEND MOC_OPTIONS -DPLD_epsqt)
  endif(PLD_epsqt)
  if(PLD_pdfqt)
    list(APPEND MOC_OPTIONS -DPLD_pdfqt)
  endif(PLD_pdfqt)
  if(PLD_qtwidget)
    list(APPEND MOC_OPTIONS -DPLD_qtwidget)
  endif(PLD_qtwidget)
  if(PLD_extqt)
    list(APPEND MOC_OPTIONS -DPLD_extqt)
  endif(PLD_extqt)
  if(MOC_OPTIONS)
    # This creates a custom command with OUTPUT ${QT_MOC_OUTFILES}.
    qt4_wrap_cpp(
      QT_MOC_OUTFILES
      ${CMAKE_SOURCE_DIR}/include/qt.h
      OPTIONS ${MOC_OPTIONS}
      )
    # Use custom target to force correct target dependencies in
    # various directories.  This target is used in three possible
    # places (qt_gui, drivers, or src) depending on build options.
    # The CMake dependency parser creates the necessary file
    # dependency on qt.h for all qt-related source code so there is no
    # need to add the ${QT_MOC_OUTFILES} file dependencies for any
    # target dependency on moc_outfiles_generated.
    add_custom_target(moc_outfile_generated DEPENDS ${QT_MOC_OUTFILES})

    # #include ${QT_MOC_OUTFILES}) indirectly via the configured moc_files.h
    # header.
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/moc_files.h.in
      ${CMAKE_CURRENT_BINARY_DIR}/moc_files.h
      )
  else(MOC_OPTIONS)
    message(FATAL_ERROR "Internal build system inconsistency between ANY_QT_DEVICE true and MOC_OPTIONS false.")
  endif(MOC_OPTIONS)
endif(ANY_QT_DEVICE)

install(FILES ${include_INSTALLED_HEADERS} DESTINATION ${INCLUDE_DIR})

=== utils/CMakeLists.txt ===
# utils/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/lib/qsastime
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/include
  )

if(USE_RPATH)
  get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
endif(USE_RPATH)

if(PLD_plmeta)
  add_executable(plrender plrender.c)

  if(BUILD_SHARED_LIBS)
    SET_SOURCE_FILES_PROPERTIES(plrender.c
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
      )
  endif(BUILD_SHARED_LIBS)
  
  target_link_libraries(plrender plplot${LIB_TAG})

  if(USE_RPATH)
    set_target_properties(plrender
      PROPERTIES
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      )
  endif(USE_RPATH)

  install(TARGETS plrender DESTINATION ${BIN_DIR})
endif(PLD_plmeta)

add_executable(pltek pltek.c)

if(BUILD_SHARED_LIBS)
  SET_SOURCE_FILES_PROPERTIES(pltek.c
    PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
endif(BUILD_SHARED_LIBS)

target_link_libraries(pltek plplot${LIB_TAG})

if(USE_RPATH)
  set_target_properties(pltek
    PROPERTIES
    INSTALL_RPATH "${LIB_INSTALL_RPATH}"
    )
endif(USE_RPATH)

install(TARGETS pltek DESTINATION ${BIN_DIR})

# Build simple executable to check parity bits of all characters read
# by stdin.
add_executable(parity_bit_check parity_bit_check.c)

=== www/CMakeLists.txt ===
# www/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Configure documentation file sizes.
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/documentation.php.in
  ${CMAKE_CURRENT_BINARY_DIR}/documentation.php @ONLY
  )

# Configure style files
add_subdirectory(css)

# Set up Makefile rules to generate announcements and validate their DocBook-XML source.
add_subdirectory(announce)

# Copy base website files to a staging area in the build tree.

set(staging_FILES)

# Create the staging directory tree at cmake time.
file(MAKE_DIRECTORY
  ${CMAKE_CURRENT_BINARY_DIR}/staging/
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce
  )

# Note documentation.php configured as above.
set(toplevel_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/corefunctions.php
  ${CMAKE_CURRENT_SOURCE_DIR}/credits.php
  ${CMAKE_CURRENT_SOURCE_DIR}/development.php
  ${CMAKE_CURRENT_SOURCE_DIR}/download.php
  ${CMAKE_CURRENT_SOURCE_DIR}/examples.php
  ${CMAKE_CURRENT_SOURCE_DIR}/index.php
  ${CMAKE_CURRENT_SOURCE_DIR}/simplepie.inc
  ${CMAKE_CURRENT_BINARY_DIR}/documentation.php
  )

foreach(_file ${toplevel_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
    )
endforeach(_file ${toplevel_FILES})

# Note style files configure by CMake above in the css (build) directory.
set(css_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/css/closelabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/loading.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/nextlabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/prevlabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/slimbox.css
  ${CMAKE_CURRENT_BINARY_DIR}/css/style_liquid.css
  ${CMAKE_CURRENT_BINARY_DIR}/css/style_static.css
  )

foreach(_file ${css_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
    )
endforeach(_file ${css_FILES})

set(img_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/img/arrow.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/bg.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/content_bg.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/drop_shadow.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/header.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_hover_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_selected_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/plplot_logo.jpg
  )

foreach(_file ${img_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
    )
endforeach(_file ${img_FILES})

set(js_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/js/slimbox.js
  )

foreach(_file ${js_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
    )
endforeach(_file ${js_FILES})

# The end of this list needs maintenance for each new release announcement
# that is generated (assuming we start making formal release announcements
# again).
set(announce_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.2.1-5.3.0
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.3.0-5.3.1
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.3.1-5.3.2
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce-plplot-5.1.0.html
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce-plplot-5.2.1.html
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce.css
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.0.xhtml
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.0.txt
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.1.xhtml
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.1.txt
  )

# This has to be handled differently because some of these files created
# with the announce subdirectory generate_announcements target.
set(staging_announce_FILES)
foreach(_file ${announce_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_announce_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
    )
endforeach(_file ${announce_FILES})

add_custom_target(
  create_staging_announce
  DEPENDS ${staging_announce_FILES}
  )
add_dependencies(create_staging_announce generate_announcements)

add_custom_target(
  create_staging
  DEPENDS ${staging_FILES}
  )
add_dependencies(create_staging create_staging_announce)

if(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
  add_custom_target(
    www-install-base
    ssh ${WWW_USER}@${WWW_HOST} mkdir -p ${WWW_DIR}/htdocs
    COMMAND rsync -avq ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/ ${WWW_USER}@${WWW_HOST}:${WWW_DIR}/htdocs
    )
  add_dependencies(www-install-base create_staging) 
endif(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)

=== bindings/ada/CMakeLists.txt ===
# bindings/ada/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2007 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_ada)

  set(SOURCE_LIST
    plplot.adb
    plplot.ads
    plplot_thin.adb
    plplot_thin.ads
    plplot_traditional.adb
    plplot_traditional.ads
    plplot_auxiliary.adb
    plplot_auxiliary.ads
    )
  
  # These are Ada library information files built by gnat.  I am not 
  # sure whether the name suffixes correspond to the *.adb or *.ads files
  # above or the union of them.  In any case, if any of the names change
  # above, then this list will probably have to be changed as well.)
  # N.B. the absolute location prefix of these files may have to be changed
  # in the future since this is a CMake internal.
  set(ALI_PREFIX 
    ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/plplotada${LIB_TAG}.dir
    )
  set(ALI_LIST
    ${ALI_PREFIX}/plplot.ali
    ${ALI_PREFIX}/plplot_thin.ali
    ${ALI_PREFIX}/plplot_traditional.ali
    ${ALI_PREFIX}/plplot_auxiliary.ali
    )

  # I am pretty sure this is a workaround for a MinGW gnatmake bug
  # since the installation of these files is not needed for Linux.
  # However, without this workaround the standard examples build on
  # MinGW/MSYS platforms without problems (so gnatmake is happy if the
  # *.o files are not installed which is another indication we are
  # dealing with a bug here), but at run-time the ada examples
  # immediately return with a return code of 3.
  if(MINGW)
    list(APPEND ALI_LIST
      ${ALI_PREFIX}/plplot.o
      ${ALI_PREFIX}/plplot_thin.o
      ${ALI_PREFIX}/plplot_traditional.o
      ${ALI_PREFIX}/plplot_auxiliary.o
      )
  endif(MINGW)

  set(plplotada${LIB_TAG}_LIB_SRCS)
  foreach(SOURCE_FILE ${SOURCE_LIST})
    list(APPEND plplotada${LIB_TAG}_LIB_SRCS 
      ${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_FILE}
      )
  endforeach(SOURCE_FILE ${SOURCE_LIST})

  add_library(plplotada${LIB_TAG} ${plplotada${LIB_TAG}_LIB_SRCS})

  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links to
    # libplplotadad in the shared libraries case.
    target_link_libraries(plplotada${LIB_TAG} LINK_INTERFACE_LIBRARIES)
    # This configures the pkg-config method to use non-transitive linking.
    set(PC_REQUIRES_TAG "Requires.private")
  else(NON_TRANSITIVE)
    # This configures the pkg-config method to use transitive linking
    set(PC_REQUIRES_TAG "Requires")
  endif(NON_TRANSITIVE)

  # Work around an issue in our CMake Ada language
  # support for MinGW/Windows.  FIXME.  This issue should be fixed
  # at the Ada language support level and not worked around here.
  if(USE_DLL_SUBDIRECTORY)
    add_custom_command(
      TARGET plplotada${LIB_TAG} POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different 
      libplplotadad.dll libplplotadad.dll.a
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/dll
      VERBATIM
      )
  endif(USE_DLL_SUBDIRECTORY)

  target_link_libraries(plplotada${LIB_TAG}
    plplot${LIB_TAG} ${GNAT_LIB}
    )

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    set_target_properties(plplotada${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotada_SOVERSION}
      VERSION ${plplotada_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotada${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotada_SOVERSION}
      VERSION ${plplotada_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)

  install(FILES ${plplotada${LIB_TAG}_LIB_SRCS} 
    DESTINATION ${ADA_INCLUDE_DIR}
    )
  
  # Permissions of *.ali files in accordance with
  # http://people.debian.org/~lbrenta/debian-ada-policy.html
  install(FILES ${ALI_LIST}
    DESTINATION ${ADA_LIB_DIR}
    PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
    )
  
  install(TARGETS plplotada${LIB_TAG}
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  # Configure pkg-config *.pc file corresponding to libplplotada${LIB_TAG}
  if(PKG_CONFIG_EXECUTABLE)
    if(LIB_TAG)
      set(PC_PRECISION "double")
    else(LIB_TAG)
      set(PC_PRECISION "single")
    endif(LIB_TAG)
    # Each list element must consist of a colon-separated string with the
    # following fields which are parsed out in the foreach loop below and
    # used to configure the corresponding pkg-config *.pc file.
    # BINDING 	      	  - ENABLE_${BINDING} keeps track of whether a
    # 			    binding has been enabled (ON) or not (OFF).
    #			    Also, ${BINDING} used to determine PC_FILE_SUFFIX
    #			    which helps to determine name of configured 
    #			    *.pc file.
    # PC_SHORT_NAME	  - Used in *.pc NAME: field
    # PC_LONG_NAME	  - Used in *.pc Description: field
    # PC_LIBRARY_NAME	  - Used in *.pc Libs: field
    #                         Also used to determine PC_LINK_FLAGS and
    #                         PC_COMPILE_FLAGS used in *.pc Libs: and Cflags:
    #			    fields.
    set(PC_DATA "ada:Ada:Ada bindings, :plplotada${LIB_TAG}")
    
    string(REGEX REPLACE "^(.*):.*:.*:.*$" "\\1" BINDING ${PC_DATA})
    set(PC_FILE_SUFFIX "-${BINDING}")
    set(PC_REQUIRES "plplot${LIB_TAG}")
    string(REGEX REPLACE "^.*:(.*):.*:.*$" "\\1" PC_SHORT_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:(.*):.*$" "\\1" PC_LONG_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:.*:(.*)$" "\\1" PC_LIBRARY_NAME ${PC_DATA})
    set(PC_LINK_FLAGS "${lib${PC_LIBRARY_NAME}_LINK_FLAGS}")
    set(PC_COMPILE_FLAGS "${lib${PC_LIBRARY_NAME}_COMPILE_FLAGS}")
    if(NON_TRANSITIVE)
      set(PC_LINK_FLAGS "-lplplot${LIB_TAG} ${PC_LINK_FLAGS}")
    endif(NON_TRANSITIVE)
    set(PC_LINK_FLAGS "-l${PC_LIBRARY_NAME} ${PC_LINK_FLAGS}")
    set(PC_CONFIGURED_FILE
      ${CMAKE_BINARY_DIR}/pkgcfg/plplot${LIB_TAG}${PC_FILE_SUFFIX}.pc
      )
    configure_file(
      ${CMAKE_SOURCE_DIR}/pkgcfg/plplot-template.pc.in
      ${PC_CONFIGURED_FILE}
      @ONLY
      )
    install(FILES ${PC_CONFIGURED_FILE} DESTINATION ${PKG_CONFIG_DIR})
  endif(PKG_CONFIG_EXECUTABLE)

  # Add generated .ali files to the list of additional files to be
  # removed by make clean
  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${ALI_LIST}")

endif(ENABLE_ada)

=== bindings/d/CMakeLists.txt ===
# bindings/d/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008 Werner Smekal
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_d)
  set(d_interface_INSTALLED_HEADERS plplot.d )

  install(FILES ${d_interface_INSTALLED_HEADERS}
    DESTINATION ${INCLUDE_DIR}
  )

  # Build d bindings
  set(plplotdmd${LIB_TAG}_LIB_SRCS
    plplot.d
  )

  if(plplotdmd_SHARED)
    add_library(plplotdmd${LIB_TAG} ${plplotdmd${LIB_TAG}_LIB_SRCS})

    if(BUILD_SHARED_LIBS)
      set_source_files_properties(${plplotdmd${LIB_TAG}_LIB_SRCS}
	PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
    endif(BUILD_SHARED_LIBS)

    target_link_libraries(plplotdmd${LIB_TAG} plplot${LIB_TAG})

    if(USE_RPATH)
      get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
      set_target_properties(plplotdmd${LIB_TAG}
	PROPERTIES
	SOVERSION ${plplotdmd_SOVERSION}
	VERSION ${plplotdmd_VERSION}
	INSTALL_RPATH "${LIB_INSTALL_RPATH}"
	INSTALL_NAME_DIR "${LIB_DIR}"
	)
    else(USE_RPATH)
      set_target_properties(plplotdmd${LIB_TAG}
	PROPERTIES
	SOVERSION ${plplotdmd_SOVERSION}
	VERSION ${plplotdmd_VERSION}
	INSTALL_NAME_DIR "${LIB_DIR}"
	)
    endif(USE_RPATH)
  else(plplotdmd_SHARED)
    add_library(plplotdmd${LIB_TAG} STATIC ${plplotdmd${LIB_TAG}_LIB_SRCS})
    target_link_libraries(plplotdmd${LIB_TAG} plplot${LIB_TAG})
  endif(plplotdmd_SHARED)

  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links to
    # libplplotdmdd in the shared libraries case.
    target_link_libraries(plplotdmd${LIB_TAG} LINK_INTERFACE_LIBRARIES)
    # This configures the pkg-config method to use non-transitive linking.
    set(PC_REQUIRES_TAG "Requires.private")
  else(NON_TRANSITIVE)
    # This configures the pkg-config method to use transitive linking
    set(PC_REQUIRES_TAG "Requires")
  endif(NON_TRANSITIVE)

  install(TARGETS plplotdmd${LIB_TAG}
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
  )

  # Configure pkg-config *.pc file corresponding to libplplotdmd${LIB_TAG}
  if(PKG_CONFIG_EXECUTABLE)
    if(LIB_TAG)
      set(PC_PRECISION "double")
    else(LIB_TAG)
      set(PC_PRECISION "single")
    endif(LIB_TAG)
    # Each list element must consist of a colon-separated string with the
    # following fields which are parsed out in the foreach loop below and
    # used to configure the corresponding pkg-config *.pc file.
    # BINDING 	      	  - ENABLE_${BINDING} keeps track of whether a
    # 			    binding has been enabled (ON) or not (OFF).
    #			    Also, ${BINDING} used to determine PC_FILE_SUFFIX
    #			    which helps to determine name of configured 
    #			    *.pc file.
    # PC_SHORT_NAME	  - Used in *.pc NAME: field
    # PC_LONG_NAME	  - Used in *.pc Description: field
    # PC_LIBRARY_NAME	  - Used in *.pc Libs: field
    #                         Also used to determine PC_LINK_FLAGS and
    #                         PC_COMPILE_FLAGS used in *.pc Libs: and Cflags:
    #			    fields.
    set(PC_DATA "d:D:D bindings, :plplotdmd${LIB_TAG}")

    string(REGEX REPLACE "^(.*):.*:.*:.*$" "\\1" BINDING ${PC_DATA})
    set(PC_FILE_SUFFIX "-${BINDING}")
    set(PC_REQUIRES "plplot${LIB_TAG}")
    string(REGEX REPLACE "^.*:(.*):.*:.*$" "\\1" PC_SHORT_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:(.*):.*$" "\\1" PC_LONG_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:.*:(.*)$" "\\1" PC_LIBRARY_NAME ${PC_DATA})
    set(PC_LINK_FLAGS "${lib${PC_LIBRARY_NAME}_LINK_FLAGS}")
    if(NON_TRANSITIVE)
      set(PC_LINK_FLAGS "-lplplot${LIB_TAG} ${PC_LINK_FLAGS}")
    endif(NON_TRANSITIVE)
    set(PC_COMPILE_FLAGS "${lib${PC_LIBRARY_NAME}_COMPILE_FLAGS}")
    set(PC_LINK_FLAGS "-l${PC_LIBRARY_NAME} ${PC_LINK_FLAGS}")
    set(PC_CONFIGURED_FILE
      ${CMAKE_BINARY_DIR}/pkgcfg/plplot${LIB_TAG}${PC_FILE_SUFFIX}.pc
      )
    configure_file(
      ${CMAKE_SOURCE_DIR}/pkgcfg/plplot-template.pc.in
      ${PC_CONFIGURED_FILE}
      @ONLY
      )
    install(FILES ${PC_CONFIGURED_FILE} DESTINATION ${PKG_CONFIG_DIR})
  endif(PKG_CONFIG_EXECUTABLE)
endif(ENABLE_d)

=== examples/ada/CMakeLists.txt ===
# examples/ada/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2007, 2008, 2009 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. This file is used for both the core build (which installs the examples
# and optionally [depending on BUILD_TEST} builds them) and the installed
# examples build.  The core build has BUILD_TEST OFF or ON at user option
# and CORE_BUILD always ON.  The installed examples build always has
# BUILD_TEST ON and CORE_BUILD OFF.

set(ada_STRING_INDICES
  "00"
  "01"
  "02"
  "03"
  "04"
  "05"
  "06"
  "07"
  "08"
  "09"
  "10"
  "11"
  "12"
  "13"
  "14"
  "15"
  "16"
  "17"
  "18"
  "19"
  "20"
  "21"
  "22"
  "23"
  "24"
  "25"
  "26"
  "27"
  "28"
  "29"
  "30"
  "31"
  "33"
  "thick00"
  "thick01"
  "thick02"
  "thick03"
  "thick04"
  "thick05"
  "thick06"
  "thick07"
  "thick08"
  "thick09"
  "thick10"
  "thick11"
  "thick12"
  "thick13"
  "thick14"
  "thick15"
  "thick16"
  "thick17"
  "thick18"
  "thick19"
  "thick20"
  "thick21"
  "thick22"
  "thick23"
  "thick24"
  "thick25"
  "thick26"
  "thick27"
  "thick28"
  "thick29"
  "thick30"
  "thick31"
  "thick33"
  )

if(CORE_BUILD)
  set(ada_SRCS)
  foreach(STRING_INDEX ${ada_STRING_INDICES})
    set(SOURCE_FILE x${STRING_INDEX}a.adb)
    list(APPEND ada_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_FILE})
  endforeach(STRING_INDEX ${ada_STRING_INDICES})

  install(FILES ${ada_SRCS} DESTINATION ${DATA_DIR}/examples/ada)

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Makefile.examples.in
    ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples
    )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples 
    DESTINATION ${DATA_DIR}/examples/ada
    RENAME Makefile
    )

  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
    DESTINATION ${DATA_DIR}/examples/ada
    )
endif(CORE_BUILD)

if(BUILD_TEST)
  if(CORE_BUILD)
    include_directories(
      ${CMAKE_BINARY_DIR}/examples/ada
      ${CMAKE_SOURCE_DIR}/bindings/ada
      )
  else(CORE_BUILD)
    include_directories(${INCLUDE_DIR} ${ADA_INCLUDE_DIR})
  endif(CORE_BUILD)

  # The first -aI option in adalinkflags is required to find <TARGET>.adb
  # (see comment below). The second -aI option gives access to the
  # libplplotada spec files. The -aL option gives access to the
  # libplplotada *.ali files.  (That location currently works but is
  # probably not guaranteed indefinitely for future versions of
  # CMake.)
  
  if(CORE_BUILD)
    set(adalinkflags "-aI${CMAKE_SOURCE_DIR}/examples/ada -aI${CMAKE_SOURCE_DIR}/bindings/ada -aL${CMAKE_BINARY_DIR}/bindings/ada/CMakeFiles/plplotada${LIB_TAG}.dir")
  else(CORE_BUILD)
    set(adalinkflags "-aI${CMAKE_SOURCE_DIR}/ada -aI${ADA_INCLUDE_DIR} -aL${ADA_LIB_DIR}")
  endif(CORE_BUILD)

  foreach(STRING_INDEX ${ada_STRING_INDICES})
    set(TARGET_NAME x${STRING_INDEX}a)
    set(SOURCE_FILE x${STRING_INDEX}a.adb)
    set(adasrcfile ${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_FILE})

    # Note due to limitations of the Ada language support for CMake,
    # the nominal source file for add_executable is compiled (which is
    # why a real file has to be specified), but otherwise it is
    # ignored except for its .adb suffix which identifies the Ada
    # language.  The actual source file name for the internal gnatmake
    # command that creates the executable is constructed from
    # <TARGET>.adb.  Since no directory can be specified from this
    # construction (don't ask), you must specify the directory of
    # <TARGET>.adb with a -aI option (see above comment of adalinkflags).
    add_executable(${TARGET_NAME} ${adasrcfile})
    
    set_target_properties(${TARGET_NAME} PROPERTIES LINK_FLAGS ${adalinkflags})
    target_link_libraries(${TARGET_NAME} plplotada${LIB_TAG} plplot${LIB_TAG})
    set_property(GLOBAL APPEND PROPERTY TARGETS_examples_ada ${TARGET_NAME})
    list(APPEND ada_extra_clean_files "${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.o;${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.ali")
  endforeach(STRING_INDEX ${ada_STRING_INDICES})

  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${ada_extra_clean_files}")
endif(BUILD_TEST)

=== examples/d/CMakeLists.txt ===
# examples/d/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008 Werner Smekal
# Copyright (C) 2009 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. This file is used for both the core build (which installs the examples
# and optionally [depending on BUILD_TEST} builds them) and the installed
# examples build.  The core build has BUILD_TEST OFF or ON at user option
# and CORE_BUILD always ON.  The installed examples build always has
# BUILD_TEST ON and CORE_BUILD OFF.

set(d_STRING_INDICES
  "00"
  "01"
  "02"
  "03"
  "04"
  "05"
  "06"
  "07"
  "08"
  "09"
  "10"
  "11"
  "12"
  "13"
  "14"
  "15"
  "16"
  "17"
  "18"
  "19"
  "20"
  "21"
  "22"
  "23"
  "24"
  "25"
  "26"
  "27"
  "28"
  "29"
  "30"
  "31"
  "33"
  )

if(CORE_BUILD) 
  set(d_SRCS)
  foreach(STRING_INDEX ${d_STRING_INDICES})
    set(d_SRCS ${d_SRCS} x${STRING_INDEX}d.d)
  endforeach(STRING_INDEX ${d_STRING_INDICES})

  install(FILES ${d_SRCS}
    DESTINATION ${DATA_DIR}/examples/d
    )

  set(DC ${CMAKE_D_COMPILER})

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Makefile.examples.in
    ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples
    )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples
    DESTINATION ${DATA_DIR}/examples/d
    RENAME Makefile
    )

  install(FILES CMakeLists.txt
    DESTINATION ${DATA_DIR}/examples/d
    )
endif(CORE_BUILD) 

if(BUILD_TEST)
  if(CORE_BUILD)
    include_directories(
      ${CMAKE_SOURCE_DIR}/bindings/d
      )
  else(CORE_BUILD)
    include_directories(${INCLUDE_DIR})
  endif(CORE_BUILD)

  set_property(GLOBAL PROPERTY TARGETS_examples_d)
  foreach(STRING_INDEX ${d_STRING_INDICES})
    add_executable(x${STRING_INDEX}d x${STRING_INDEX}d.d)
    target_link_libraries(x${STRING_INDEX}d plplotdmd${LIB_TAG} plplot${LIB_TAG} ${MATH_LIB})
    set_property(GLOBAL APPEND PROPERTY TARGETS_examples_d x${STRING_INDEX}d)
  endforeach(STRING_INDEX ${d_STRING_INDICES})
endif(BUILD_TEST)

=== examples/perl/CMakeLists.txt ===
# examples/perl/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. This file is used for both the core build (which installs the examples
# and optionally [depending on BUILD_TEST} builds them) and the installed
# examples build.  The core build has BUILD_TEST OFF or ON at user option
# and CORE_BUILD always ON.  The installed examples build always has
# BUILD_TEST ON and CORE_BUILD OFF.

set(perl_STRING_INDICES
  "01"
  "02"
  "03"
  "04"
  "05"
  "06"
  "07"
  "08"
  "09"
  "10"
  "11"
  "12"
  "13"
  "14"
  "15"
  "16"
  "17"
  "18"
  "19"
  "20"
  "21"
  "22"
  "23"
  "24"
  "25"
  "26"
  "27"
  "28"
  "29"
  "30"
  "31"
  "33"
  )

set(perl_SCRIPTS)
foreach(STRING_INDEX ${perl_STRING_INDICES})
  list(APPEND perl_SCRIPTS ${CMAKE_CURRENT_SOURCE_DIR}/x${STRING_INDEX}.pl)
endforeach(STRING_INDEX ${c_STRING_INDICES})

# Target that must be run before any pdl tests.
set_property(GLOBAL PROPERTY TARGETS_examples_pdl plplot${LIB_TAG})
# File dependencies for any pdl tests.
set_property(GLOBAL PROPERTY FILES_examples_pdl plplot${LIB_TAG} ${perl_SCRIPTS})

if(CORE_BUILD)
  set(PERM_SCRIPTS
    OWNER_READ
    OWNER_WRITE
    OWNER_EXECUTE
    GROUP_READ
    GROUP_EXECUTE
    WORLD_READ
    WORLD_EXECUTE
    )

  # These are standalone scripts which are executable and which
  # should be installed in the examples/perl directory.
  install(FILES ${perl_SCRIPTS}
    DESTINATION ${DATA_DIR}/examples/perl
    PERMISSIONS ${PERM_SCRIPTS}
    )

  set(perl_DATA README.perldemos)

  set(PERM_DATA
    OWNER_READ
    OWNER_WRITE
    GROUP_READ
    WORLD_READ
    )

  # These are data files which should be installed in the examples/perl
  # directory.
  install(FILES ${perl_DATA}
    DESTINATION ${DATA_DIR}/examples/perl
    PERMISSIONS ${PERM_DATA}
    )

  install(FILES CMakeLists.txt 
    DESTINATION ${DATA_DIR}/examples/perl
    )

endif(CORE_BUILD)

=== debian/changelog ===
plplot (5.10.0-0ubuntu5) trusty; urgency=medium

  * New upstream version.
  * Bump sonames.
  * Build using lua5.2.
  * Build-depend on iwidgets4, still build using Tcl/Tk 8.5, same version
    as used for itcl3.
  * Disable building the octave-plplot package, running the octave tests
    lets the builds hang.
  * Honor nocheck in DEB_BUILD_OPTIONS.
  * Enable verbose builds and tests.
  * Build-depend on xvfb and xauth, run configure using xvfb-run.
  * Fix debian plplot version detection.
  * Remove multiarch path in pkgconfig files.
  * Build-depend on dblatex, openjade, xmlto.
  * plConfig.h: Don't try to include the internal plplot_config.h in the
    installed header file.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Feb 2014 12:21:44 +0100

plplot (5.9.9-5ubuntu8) trusty; urgency=medium

  * Remove build dependeny on gnat on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Feb 2014 03:23:18 +0100

plplot (5.9.9-5ubuntu7) trusty; urgency=medium

  * Fix build with Tcl 8.6.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Feb 2014 02:21:19 +0100

plplot (5.9.9-5ubuntu6) trusty; urgency=medium

  * Rebuild for octave 3.8.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Feb 2014 23:50:44 +0000

plplot (5.9.9-5ubuntu5) trusty; urgency=medium

  * rebuild for libqhull6

 -- Julian Taylor <jtaylor@ubuntu.com>  Sun, 23 Feb 2014 13:41:33 +0100

plplot (5.9.9-5ubuntu4) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:02:15 +0000

plplot (5.9.9-5ubuntu3) trusty; urgency=low

  * Don't build the gnat bindings on AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Oct 2013 23:48:35 +0200

=== debian/control ===
Source: plplot
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Andrew Ross <andrewross@users.sourceforge.net>
Standards-Version: 3.9.3
Build-Depends: cmake (>= 2.6.3), debhelper (>= 7), 
 tcl8.5-dev, tk8.5-dev, itcl3-dev, iwidgets4, libx11-dev, libxext-dev,
 libxi-dev, gfortran, itk3-dev, liboctave-dev,
 libgd2-noxpm-dev | libgd2-xpm-dev, m4, libqhull-dev (>= 2003.1-8), 
 libxml-parser-perl, libxml-dom-perl, libltdl3-dev, pkg-config, 
 quilt, slice, python-gtk2-dev, libwxgtk2.8-dev, 
 python-all-dev (>= 2.6.6-3~),
 python-numpy (>= 1:1.4.1-4~), ttf-freefont, default-jdk,
 fastjar, swig, gnat [!arm64 !ppc64el !sh4], libqt4-dev, python-sip-dev, 
 python-qt4, python-qt4-dev,
 ocaml-nox, camlidl, ocaml-findlib, libcairo-ocaml-dev,
 liblablgtk2-ocaml-dev, liblua5.2-dev, lua5.2,
 xvfb, xauth, patch
Build-Depends-Indep: docbook-xml, docbook, docbook-dsssl, docbook-xsl,
 docbook2x, opensp, jadetex, ghostscript, openjade, dblatex, xmlto
Build-Conflicts: libplplot5, libpython3.3-dev, libpython3.4-dev, tcl-dev, tcl8.6
X-Python-Version: >=2.4
Homepage: http://www.plplot.org
Vcs-Svn: https://plplot.svn.sourceforge.net/svnroot/plplot/trunk/debian
Vcs-Browser: http://plplot.svn.sourceforge.net/viewvc/plplot/trunk/debian/

Package: libplplot12
Architecture: any
Section: libs
Conflicts: libplplot9, libplplot11
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: plplot12-driver-xwin, plplot12-driver-gd,
 plplot12-driver-cairo, plplot12-driver-qt, plplot12-driver-wxwidgets, plplot-tcl
Replaces: plplot-bin (<< 5.9.6-1)
Breaks: plplot-bin (<<5.9.6-1)
Description: Scientific plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the PLplot library for C, as well as the necessary
 data files.

Package: libplplot-dev
Architecture: any
Section: libdevel
Recommends: pkg-config, cmake, libplplot-ocaml, libplplot-lua, libplplot-d
Suggests: plplot-doc
Depends: libplplot12 (= ${binary:Version}), libqhull-dev, libfreetype6-dev,
 libltdl3-dev, libqsastime-dev, ${misc:Depends}, 
 libplplot-c++11 (= ${binary:Version}), libplplot-fortran11 (= ${binary:Version})
Breaks: libplplot-fortran9 (<< 5.9.8-1)
Description: Scientific plotting library (development files)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains all that is needed for doing development in C, C++
 and Fortran with PLplot.  Examples of programs for these languages are
 also included.  For development in Tcl/Tk, Python, Octave, Ada and Java 
 install the plplot-tcl-dev, python-plplot, octave-plplot, libplplot-ada0-dev
 and libplplot-java packages, respectively. This package also includes the 
 OCaml, lua and D examples. To use one of these languages you will also 
 need to install the libplplot-xxx package for that language.

Package: libplplot-c++11
Architecture: any
Section: libs
Conflicts: libplplot5, libplplot-c++9, libplplot-c++9c2, libplplot-c++10
Replaces: libplplot-c++9c2, libplplot-c++10
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scientific plotting library (C++ binding)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the C++ binding for PLplot.

Package: libplplot-fortran11
Architecture: any
Section: libs
Depends: ${shlibs:Depends}  , ${misc:Depends}
Description: Scientific plotting library (fortran bindings)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Fortran 77 and Fortran 95 bindings for
 PLplot. Note: the Fortran 77 bindings have been deprecated in the latest
 version of PLplot, and will be dropped from a future release. New code
 should use the Fortran 95 bindings.

Package: libplplot-java
Architecture: any
Section: java
Conflicts: libplplot9-java
Replaces: libplplot9-java
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scientific plotting library (Java bindings)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Java bindings for PLplot.

Package: libcsiro0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scientific plotting library (CSIRO libraries)
 This package contains two libraries developed by Pavel Sakov, from the
 CSIRO Marine Research, used in geometry applications:
 .
  * libcsirocsa: bivariate Cubic Spline Approximation library
  * libcsironn: Natural Neighbours interpolation library
 .
 The source code for these libraries are part of the plplot source
 package.

Package: libqsastime0
Architecture: any
Section: libs
Conflicts: libplplot9
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Time format conversion library
 The qsastime library is a simple library for handling time format
 conversion. It overcomes the limitations of the POSIX time handling
 routines by allow high precision time variables over a large range
 of ranges of dates and by correctly handling leap seconds. It was
 designed with the needs of scientific data plotting in mind. This 
 package provides the runtime library.
 .
 The source code for this library is part of the plplot source
 package.

Package: libqsastime-dev
Architecture: any
Section: libdevel
Breaks: libplplot-dev (<< 5.9.8-1)
Depends: libqsastime0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Time format conversion library (development files)
 The qsastime library is a simple library for handling time format
 conversion. It overcomes the limitations of the POSIX time handling
 routines by allow high precision time variables over a large range
 of ranges of dates and by correctly handling leap seconds. It was
 designed with the needs of scientific data plotting in mind. This 
 package provides the necessary files to do development with 
 libqsastime.
 .
 The source code for this library is part of the plplot source
 package.

Package: plplot12-driver-xwin
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: plplot9-driver-xwin, plplot11-driver-xwin
Replaces: plplot9-driver-xwin, plplot11-driver-xwin
Description: Scientific plotting library (X11 driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package provides the X11 driver module for PLplot.

Package: plplot12-driver-wxwidgets
Architecture: any
Section: libs
Depends: libplplot12, ${shlibs:Depends}, ${misc:Depends}
Conflicts: plplot9-driver-wxwidgets, plplot11-driver-wxwidgets
Replaces: plplot9-driver-wxwidgets, plplot11-driver-wxwidgets
Description: Scientific plotting library (wxWidgets driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package provides the wxWidgets driver module for PLplot.

Package: plplot-tcl
Architecture: any
Depends: plplot12-driver-xwin, iwidgets4, ${shlibs:Depends}, ${misc:Depends}
Description: Tcl/Tk support for PLplot, a plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Tcl/Tk support for PLplot: shared libraries,
 Tcl modules, the Tk driver, and some programs for interactive use of
 PLplot (plserver and pltcl). 

Package: plplot-tcl-dev
Architecture: any
Depends: libplplot12 (= ${binary:Version}), plplot-tcl, ${misc:Depends}
Breaks: plplot-tcl (<= 5.2.0.cvs.20030224-1)
Description: Tcl/Tk development support for PLplot, a plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the necessary files to do development in Tcl/Tk
 with PLplot: header files, shared libraries links, and examples.

Package: plplot12-driver-gd
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: plplot9-driver-gd, plplot11-driver-gd
Replaces: plplot9-driver-gd, plplot11-driver-gd
Recommends: ttf-freefont
Description: Scientific plotting library (GD driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package

=== debian/rules ===
#!/usr/bin/make -f
# -*- gmake -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independant
# package.
# Modified by Rafael Laboissiere <rafael@debian.org> on 1998/06/12
# for the plplot package

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

with_oct := $(if $(filter octave-plplot, $(shell dh_listpackages)),yes)

ifeq ($(with_oct),yes)
  # Paths for Octave
  MDIR = $(shell octave-config --print LOCALAPIFCNFILEDIR)
  OCTDIR = $(shell octave-config --print LOCALAPIOCTFILEDIR)
  octver := $(shell octave-config -v)
endif

#include /usr/share/quilt/quilt.make

version		:= $(shell perl debian/get-upstream-version.pl < cmake/modules/plplot_version.cmake)
libpkg          := libplplot12
docpkg          := plplot-doc
debbase		:= $(shell pwd)/debian
debtmp		:= $(debbase)/tmp
debusr		:= $(debtmp)/usr
deblib		:= $(debusr)/lib
debshr		:= $(debusr)/share
debdoc		:= $(debshr)/doc
debinfo		:= $(debshr)/info
debex		:= $(debshr)/plplot$(version)/examples

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -fvisibility=hidden
#Don't add -fvisibility=hidden to CXXFLAGS for now as this breaks the octave bindings.
CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
#CXXFLAGS += -fvisibility=hidden
FFLAGS = $(shell dpkg-buildflags --get FFLAGS)
FFLAGS += -fvisibility=hidden
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS += -Wl,--as-needed

export verbose_test = on

JAVA_HOME = /usr/lib/jvm/default-java

PYVERS = $(shell pyversions -vr)

OCAMLABI := $(shell ocamlc -version)
OFILES := $(filter-out debian/control,$(patsubst %.in,%,$(wildcard debian/*.in)))

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Disable Ada build on armel - gnat not available on armel at the moment.

#ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:arm64:sh4:))
BUILD_ADA = no
#else
#BUILD_ADA = yes
#endif

# Configure options

ifeq ($(BUILD_ADA),yes)
ADA_OPTIONS = -DENABLE_ada=ON
else
ADA_OPTIONS = -DENABLE_ada=OFF
endif

JAVA_OPTIONS = \
	-DCMAKE_Java_RUNTIME=$(JAVA_HOME)/bin/java \
	-DCMAKE_Java_COMPILER=$(JAVA_HOME)/bin/javac \
	-DCMAKE_Java_ARCHIVE=$(JAVA_HOME)/bin/jar

CONFIGURE_OPTIONS = \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOC=OFF -DCMAKE_INSTALL_PREFIX=/usr \
	-DUSE_RPATH=OFF -DPLD_psttf=OFF -DENABLE_tk=ON \
	-DPLD_jpeg=ON -DPLD_png=ON -DPLD_gif=ON \
        -DTCL_TCLSH=/usr/bin/tclsh8.5 \
	$(ADA_OPTIONS) $(JAVA_OPTIONS) 

ifeq ($(with_oct),yes)
  CONFIGURE_OPTIONS += -DOCTAVE_OCT_DIR=$(OCTDIR)
endif

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  CONFIGURE_OPTIONS += -DBUILD_TEST=ON
endif

BUILD_DIR = $(debbase)/build_tmp
SRC_DIR = $(shell pwd)

control:
ifeq ($(BUILD_ADA),no)
	slice -o UNDEF+ADA:debian/control debian/control.in
else
	slice -o UNDEF+ADA:debian/control debian/control.in
endif

config: config-stamp
config-stamp: control 
	mkdir -p $(BUILD_DIR)
	(cd $(BUILD_DIR) ; \
	PKG_CONFIG_ENV=" " F77=gfortran FC=gfortran \
	JAVA_HOME=$(JAVA_HOME) \
        CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" FFLAGS="$(FFLAGS)" \
        LDFLAGS="$(LDFLAGS)" \
	xvfb-run cmake $(SRC_DIR) $(CONFIGURE_OPTIONS) )
	touch config-stamp

build-arch: build-arch-stamp
build-arch-stamp: config-stamp
	dh_testdir
	( cd $(BUILD_DIR) ; $(MAKE)  )
	-( cd $(BUILD_DIR) ; unset DISPLAY ; $(MAKE) test_noninteractive )
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: 
	dh_testdir
	( cd $(BUILD_DIR) ; cmake $(SRC_DIR) $(CONFIGURE_OPTIONS) -DBUILD_DOC=ON ; \
	cd doc ; $(MAKE)  )
	touch build-indep-stamp

clean: 
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp install-arch-stamp install-indep-stamp \
              config-stamp debian/files install-python*
	rm -rf $(BUILD_DIR)
	rm -rf $(debbase)/$(libpkg)
	dh_clean

install-arch: install-arch-stamp install-python
	dh_movefiles -a --no-package=$(libpkg) --no-package=libplplot-dev \
		     --no-package=python-plplot --no-package=python-plplot-qt   \
		     --no-package=libplplot-java --no-package=libplplot-ada0 \
	             --no-package=libplplot-ocaml --no-package=libplplot-lua \
	             --no-package=libplplot-d --no-package=libplplot-ada0-dev
	dh_movefiles --package=python-plplot-qt
	dh_movefiles --package=python-plplot
	dh_movefiles --package=libplplot-java
	dh_movefiles --package=libplplot-ocaml
	dh_movefiles --package=libplplot-lua
ifeq ($(BUILD_ADA),yes)
	dh_movefiles --package=libplplot-ada0
	dh_movefiles --package=libplplot-ada0-dev 
endif
	dh_movefiles --package=libplplot-dev
	dh_movefiles --package=$(libpkg)

install-arch-stamp: build-arch-stamp
	dh_testdir
	dh_testroot

ifeq ($(with_oct),yes)
	# Strip bindings/octave/plplot_octave.oct as this is missed by 
        # dh_strip.
	strip --strip-unneeded --remove-section=.comment $(BUILD_DIR)/bindings/octave/plplot_octave.oct
endif

	( cd $(BUILD_DIR) ; \
	  $(MAKE) DESTDIR=$(debtmp) install )

	patch -d $(debtmp)/usr/include -p1 < debian/no-plplot_config.h.diff

	( cd $(debdoc)/plplot ; \
	  rm -f COPYING.LIB *.dvi ; \
	  mv ChangeLog.release changelog )
	mv $(debdoc)/plplot $(debdoc)/$(libpkg)

	sed -i 's,-L/usr/lib/$(DEB_HOST_MULTIARCH),,g;s,  *, ,g' \
		$(deblib)/pkgconfig/*.pc
	mkdir -p $(deblib)/$(DEB_HOST_MULTIARCH)/pkgconfig
	mafiles=$$(fgrep -l $(deblib)/pkgconfig/*.pc); \
	if [ -n "$$mafiles" ]; then \
	  mv $$mafiles $(deblib)/$(DEB_HOST_MULTIARCH)/pkgconfig/.; \
	fi

	install -d $(debex)/perl
	install --mode=644 examples/perl/x* examples/perl/README* \
		$(debex)/perl
	mv $(debex) $(debdoc)/$(libpkg)

	for i in libplplot-dev plplot-tcl plplot-tcl-dev 		\
		plplot12-driver-gd plplot12-driver-xwin 		\
		$(if $(filter yes,$(with_oct)),octave-plplot)		\
		python-plplot-qt                                        \
		python-plplot libplplot-c++11 plplot12-driver-wxwidgets \
		plplot12-driver-qt libplplot-java			\
		plplot12-driver-cairo libplplot-fortran11		\
		libplplot-ocaml libplplot-lua ; do			\
	  ln -s $(libpkg) $(debdoc)/$$i ;				\
	done
	ln -s libqsastime0 $(debdoc)/libqsastime-dev

	mv $(debshr)/java/plplot.jar $(debshr)/java/plplot-$(version).jar
	( cd $(debshr)/java ; ln -s plplot-$(version).jar plplot.jar )

ifeq ($(BUILD_ADA),yes)
	ln -s $(libpkg) $(debdoc)/libplplot-ada0
	ln -s $(libpkg) $(debdoc)/libplplot-ada0-dev
endif

	touch install-arch-stamp

install-indep: install-indep-stamp
	dh_movefiles -i

install-indep-stamp: build-indep-stamp
	( cd $(BUILD_DIR)/doc ; \
	  $(MAKE) DESTDIR=$(debtmp) install )

	mkdir -p $(debdoc)/$(docpkg)
	(cd $(debdoc)/plplot ; mv html $(debdoc)/$(docpkg))
	cp doc/docbook/src/plplot-$(version).pdf $(debdoc)/$(docpkg)/plplot.pdf
	touch install-indep-stamp

install-python: $(PYVERS:%=install-python%)
	touch $@

install-python%: build-arch-stamp
	( cd $(BUILD_DIR) ; \
	  cmake $(SRC_DIR) $(CONFIGURE_OPTIONS) -DPYTHON_EXECUTABLE=/usr/bin/python$* -DPYTHON_LIBRARIES=/usr/lib/python$* -DPYTHON_LIBRARY=$$(python$*-config --configdir)/libpython$*.so -DPYTHON_INCLUDE_PATH="/usr/include/python$*;/usr/include/numpy;/usr/lib/pyshared/python$*/numpy/core/include/numpy"  -DNUMERIC_INCLUDE_PATH=/usr/include/numpy ; \
	  for d in python qt_gui/pyqt4 ; do		\
	    ( cd bindings/$$d;				\
	      $(MAKE) clean ;				\
	      $(MAKE) ;					\
	      $(MAKE) DESTDIR=$(debtmp) install ) ;	\
	  done )
	touch $@

# Build architecture-independent files here.
binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_installdocs --package=$(docpkg)
	dh_installchangelogs --package=$(docpkg)
	dh_compress -i --exclude=.pdf
	dh_fixperms -i
	dh_installdeb -i
	dh_lintian -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build-arch install-arch
	dh_testdir -a
	dh_testroot -a
	dh_installdirs -a

	dh_installdocs --package=$(libpkg) --package=libcsiro0 --package=libqsastime0

=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/" \
  http://sf.net/plplot/plplot-(.*)\.tar\.gz
